DEF VAR ckeystring       AS CHAR       NO-UNDO.
DEF VAR ckeystring_extra AS CHAR       NO-UNDO.

FIND FIRST sp-invoice_key WHERE
           sp-invoice_key.applicationcode = "CA"
       AND sp-invoice_key.field_name = "shipment_seqnr"
           NO-LOCK NO-ERROR.
FOR EACH sp-company:

  FOR EACH aa-invoice_header WHERE
           aa-invoice_header.companycode = sp-company.companycode
       AND aa-invoice_header.applicationcode = "CA"
       AND aa-invoice_header.invoicenr = 0
           EXCLUSIVE-LOCK:
    cKeystring       = ENTRY(1,aa-invoice_header.keystring,CHR(4)).
    cKeystring_extra = ENTRY(2,aa-invoice_header.keystring,CHR(4)).
    
    IF SUBSTRING(cKeystring_extra,27) = "outward"
    THEN DO:
      IF AVAIL sp-invoice_key 
      THEN cKeystring = SUBSTRING(cKeystring,1,34) + SUBSTRING("CU" + FILL(" ":U,16),1,16).
      ELSE DO:
        FIND ca-u_shipment WHERE 
             ca-u_shipment.companycode = sp-company.companycode
         AND ca-u_shipment.bookingnr   = SUBSTRING(cKeystring,27)
             NO-LOCK NO-ERROR.
             IF AVAIL ca-u_shipment 
             THEN cKeystring = SUBSTRING(cKeystring,1,26) + STRING(ca-u_shipment.shipment_seqnr,"99999999") + SUBSTRING("CU" + FILL(" ":U,16),1,16).
             ELSE cKeystring = SUBSTRING(cKeystring,1,26) + "00000000" + SUBSTRING("CU" + FILL(" ":U,16),1,16).
      END.
    END.
    ELSE DO:
      IF AVAIL sp-invoice_key 
      THEN cKeystring = SUBSTRING(cKeystring,1,34) + SUBSTRING("CI" + FILL(" ":U,16),1,16).
      ELSE DO:
        FIND ca-i_shipment WHERE 
             ca-i_shipment.companycode = sp-company.companycode
         AND ca-i_shipment.bl-number   = SUBSTRING(cKeystring,27)
             NO-LOCK NO-ERROR.
             IF AVAIL ca-i_shipment 
             THEN cKeystring = SUBSTRING(cKeystring,1,26) + STRING(ca-i_shipment.shipment_seqnr,"99999999") + SUBSTRING("CI" + FILL(" ":U,16),1,16).
             ELSE cKeystring = SUBSTRING(cKeystring,1,26) + "00000000" + SUBSTRING("CI" + FILL(" ":U,16),1,16).
      END.
    END.
    aa-invoice_header.keystring = cKeystring + CHR(4) + cKeystring_extra.       

MESSAGE cKeystring  VIEW-AS ALERT-BOX.
  END.
END.

