
{system/conversion/conversion_progress.i}

/*------------------------------------------------------------------------
  File: CA/conversion/12.04/ca-1204-before-01-fax.p
  Doel: Fax service werkt al jaren niet meer -> verwijderen uit schedulers
------------------------------------------------------------------------*/
  DEF VAR cProgram                      AS CHARACTER NO-UNDO.
  DEF VAR cAction                       AS CHARACTER NO-UNDO.
  DEF VAR cTable                        AS CHARACTER NO-UNDO.
  DEF VAR iDone                         AS INTEGER   NO-UNDO.
  DEF VAR iTotal                        AS INTEGER   NO-UNDO.

  DISABLE TRIGGERS FOR LOAD OF ca-edi_receiver.
  DISABLE TRIGGERS FOR LOAD OF ca-edi_sender.

  DEF BUFFER b-ca-edi_receiver FOR ca-edi_receiver.
  DEF BUFFER b-ca-edi_sender   FOR ca-edi_sender.

  ASSIGN
    cProgram = "ca-1204-before-01-fax.p"
    cAction  = "Delete fax records"
    cTable   = ""
    iTotal   = 0
    iDone    = 0
    .

  RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).

  DO TRANSACTION:

    FOR EACH b-ca-edi_receiver WHERE
             b-ca-edi_receiver.service_code = "FAX"
      EXCLUSIVE-LOCK:

      DELETE b-ca-edi_receiver.
      ASSIGN
        iTotal = iTotal + 1
        iDone  = iDone + 1.

    END.

    FOR EACH b-ca-edi_sender WHERE
             b-ca-edi_sender.service_code = "FAX"
      EXCLUSIVE-LOCK:

      DELETE b-ca-edi_sender.

      ASSIGN
        iTotal = iTotal + 1
        iDone  = iDone + 1.
    END.

  END. /* DO TRANSACTION */

  RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).
  
